package com.futu.course.shop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.futu.course.common.entity.R;
import com.futu.course.course.domain.Course;
import com.futu.course.course.mapper.CourseMapper;
import com.futu.course.shop.domain.Shop;
import com.futu.course.shop.dto.ShopDto;
import com.futu.course.shop.service.ShopService;
import com.futu.course.shop.mapper.ShopMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
* @author yuu
* @description 针对表【shop(店铺表)】的数据库操作Service实现
* @createDate 2025-05-05 18:53:08
*/
@Service
public class ShopServiceImpl extends ServiceImpl<ShopMapper, Shop>
    implements ShopService{

    @Resource
    private CourseMapper courseMapper;

    @Override
    public R findeAdd(ShopDto shopDto) {
        System.err.println(shopDto);
        Shop shop = this.baseMapper.selectById(shopDto.getShopId());
        List<Course> courses = courseMapper.selectList(new QueryWrapper<Course>().eq("shop_id", shop.getId()));
        System.err.println(courses);
        shop.setCourses(courses);
        return R.ok(shop);
    }
}




